package sendmail.gui;

import sendmail.mail.*;
import sendmail.util.*;
import java.util.Vector;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


/**
 * Title:        SendMail
 * Description:  This is the main GUI class where the application starts running and the GUI is shown for user information.
 * Copyright:    Copyright (c) 2002
 * Company:      NPI
 * @author Phanindra K Nayani
 * @version 1.0
 */

public class SendMail extends JFrame {
  JScrollPane jScrollPane1 = new JScrollPane();
  JPanel Panel_Main = new JPanel();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JTextField Edit_UserName = new JTextField();
  JTextField Edit_Password = new JTextField();
  JLabel jLabel5 = new JLabel();
  JTextField Edit_SmtpServer = new JTextField();
  JLabel jLabel6 = new JLabel();
  JTextField Edit_Pop3Server = new JTextField();
  JLabel jLabel7 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JTextField Edit_MailID = new JTextField();
  JLabel jLabel8 = new JLabel();
  JLabel jLabel9 = new JLabel();
  JTextField Edit_Subject = new JTextField();
  JLabel jLabel10 = new JLabel();
  JTextField Edit_ContentFile = new JTextField();
  JLabel jLabel11 = new JLabel();
  JTextField Edit_ToFile = new JTextField();
  JLabel jLabel12 = new JLabel();
  JTextField Edit_AttachmentFile1 = new JTextField();
  JCheckBox CheckBox_SendCopyToMe = new JCheckBox();
  JLabel jLabel13 = new JLabel();
  JTextField Edit_AttachmentFile2 = new JTextField();
  JLabel jLabel14 = new JLabel();
  JTextField Edit_AttachmentFile3 = new JTextField();
  JButton Button_ContentFile = new JButton();
  JButton Button_ToFile = new JButton();
  JButton Button_AttachmentFile1 = new JButton();
  JButton Button_AttachmentFile2 = new JButton();
  JButton Button_AttachmentFile3 = new JButton();
  JScrollPane jScrollPane2 = new JScrollPane();
  DefaultListModel listModelStatus = new DefaultListModel();
  JList List_Status = new JList(listModelStatus);
  JButton Button_Send = new JButton();
  JButton Button_Exit = new JButton();
  JButton Button_Help = new JButton();
  JButton Button_Clear = new JButton();
    JLabel jLabel15 = new JLabel();
    JLabel jLabel16 = new JLabel();
    JLabel jLabel17 = new JLabel();
    JLabel jLabel18 = new JLabel();
    JComboBox ComboBox_Delay = new JComboBox();





  public SendMail() {
    try {
      jbInit();
    }
    catch(Exception e) {
      JOptionPane.showMessageDialog(null, "Application Cant be started due to serious errors, please refer to the documentation");
      e.printStackTrace();
    }
  }





  public static void main(String[] args) {
    try {
        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    } catch (Throwable th) {
    }

    SendMail sendMail1 = new SendMail();
    sendMail1.setSize(630, 530);
    sendMail1.show();
  }




  private void jbInit() throws Exception {
    Panel_Main.setLayout(null);
    jLabel1.setFont(new java.awt.Font("Dialog", 1, 18));
    jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel1.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel1.setText("Send Mails !!!");
    jLabel1.setBounds(new Rectangle(-3, 0, 614, 38));
    jLabel2.setFont(new java.awt.Font("Dialog", 1, 16));
    jLabel2.setText("Your Mail Account/Server Info");
    jLabel2.setBounds(new Rectangle(6, 43, 240, 30));
    jLabel3.setFont(new java.awt.Font("Dialog", 1, 13));
    jLabel3.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel3.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel3.setText("Username");
    jLabel3.setBounds(new Rectangle(25, 107, 77, 26));
    Edit_UserName.setBounds(new Rectangle(105, 108, 179, 24));
    Edit_Password.setFont(new java.awt.Font("Dialog", 0, 5));
        Edit_Password.setVerifyInputWhenFocusTarget(false);
        Edit_Password.setBounds(new Rectangle(105, 137, 179, 25));
    jLabel5.setBounds(new Rectangle(25, 135, 77, 26));
    jLabel5.setText("Password");
    jLabel5.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel5.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel5.setFont(new java.awt.Font("Dialog", 1, 13));
    Edit_SmtpServer.setToolTipText("");
    Edit_SmtpServer.setText(" ");
    Edit_SmtpServer.setBounds(new Rectangle(408, 82, 179, 23));
    jLabel6.setBounds(new Rectangle(316, 79, 89, 26));
    jLabel6.setText("SMTP Server");
    jLabel6.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel6.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel6.setFont(new java.awt.Font("Dialog", 1, 13));
    Edit_Pop3Server.setBounds(new Rectangle(408, 109, 179, 23));
    jLabel7.setBounds(new Rectangle(316, 107, 89, 26));
    jLabel7.setText("POP3 Server");
    jLabel7.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel7.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel7.setFont(new java.awt.Font("Dialog", 1, 13));
    jLabel4.setBounds(new Rectangle(12, 179, 240, 30));
    jLabel4.setText("Mail Content Information");
    jLabel4.setFont(new java.awt.Font("Dialog", 1, 16));
    Edit_MailID.setBounds(new Rectangle(105, 80, 179, 24));
    jLabel8.setBounds(new Rectangle(25, 79, 77, 26));
    jLabel8.setText("Full Mail ID");
    jLabel8.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel8.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel8.setFont(new java.awt.Font("Dialog", 1, 13));
    jLabel9.setFont(new java.awt.Font("Dialog", 1, 13));
    jLabel9.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel9.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel9.setText("Default Mail Subject");
    jLabel9.setBounds(new Rectangle(40, 210, 136, 26));
    Edit_Subject.setBounds(new Rectangle(180, 211, 267, 24));
    jLabel10.setFont(new java.awt.Font("Dialog", 1, 13));
    jLabel10.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel10.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel10.setText("Mail Content File(.txt)");
    jLabel10.setBounds(new Rectangle(34, 238, 142, 26));
    Edit_ContentFile.setEditable(false);
    Edit_ContentFile.setBounds(new Rectangle(180, 239, 267, 24));
    jLabel11.setFont(new java.awt.Font("Dialog", 1, 13));
    jLabel11.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel11.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel11.setText("File With To & Subject");
    jLabel11.setBounds(new Rectangle(15, 265, 161, 26));
    Edit_ToFile.setEditable(false);
    Edit_ToFile.setBounds(new Rectangle(180, 266, 267, 24));
    jLabel12.setBounds(new Rectangle(51, 293, 125, 26));
    jLabel12.setText("Attachment File #1");
    jLabel12.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel12.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel12.setFont(new java.awt.Font("Dialog", 1, 13));
    Edit_AttachmentFile1.setBounds(new Rectangle(180, 294, 267, 24));
    Edit_AttachmentFile1.setEditable(false);
    CheckBox_SendCopyToMe.setFont(new java.awt.Font("Dialog", 1, 13));
    CheckBox_SendCopyToMe.setText("Send a copy to my mailbox ");
    CheckBox_SendCopyToMe.setBounds(new Rectangle(324, 139, 198, 25));
    jLabel13.setFont(new java.awt.Font("Dialog", 1, 13));
    jLabel13.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel13.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel13.setText("Attachment File #2");
    jLabel13.setBounds(new Rectangle(51, 320, 125, 26));
    Edit_AttachmentFile2.setEditable(false);
        Edit_AttachmentFile2.setBounds(new Rectangle(180, 321, 267, 24));
    jLabel14.setFont(new java.awt.Font("Dialog", 1, 13));
    jLabel14.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel14.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel14.setText("Attachment File #3");
    jLabel14.setBounds(new Rectangle(52, 347, 125, 26));
    Edit_AttachmentFile3.setEditable(false);
        Edit_AttachmentFile3.setBounds(new Rectangle(180, 348, 267, 24));
    Button_ContentFile.setFont(new java.awt.Font("Dialog", 1, 12));
    Button_ContentFile.setText("...");
    Button_ContentFile.setBounds(new Rectangle(449, 239, 22, 24));
    Button_ContentFile.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Button_ContentFile_actionPerformed(e);
      }
    });
    Button_ToFile.setBounds(new Rectangle(449, 265, 22, 24));
    Button_ToFile.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Button_ToFile_actionPerformed(e);
      }
    });
    Button_ToFile.setText("...");
    Button_ToFile.setFont(new java.awt.Font("Dialog", 1, 12));
    Button_AttachmentFile1.setBounds(new Rectangle(449, 293, 22, 24));
    Button_AttachmentFile1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Button_AttachmentFile1_actionPerformed(e);
      }
    });
    Button_AttachmentFile1.setText("...");
    Button_AttachmentFile1.setFont(new java.awt.Font("Dialog", 1, 12));
    Button_AttachmentFile2.setBounds(new Rectangle(450, 320, 22, 24));
    Button_AttachmentFile2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Button_AttachmentFile2_actionPerformed(e);
      }
    });
    Button_AttachmentFile2.setText("...");
    Button_AttachmentFile2.setFont(new java.awt.Font("Dialog", 1, 12));
    Button_AttachmentFile3.setBounds(new Rectangle(450, 346, 22, 24));
    Button_AttachmentFile3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Button_AttachmentFile3_actionPerformed(e);
      }
    });
    Button_AttachmentFile3.setText("...");
    Button_AttachmentFile3.setFont(new java.awt.Font("Dialog", 1, 12));
    jScrollPane2.setBounds(new Rectangle(4, 392, 611, 105));
    Button_Send.setFont(new java.awt.Font("Dialog", 0, 15));
    Button_Send.setText("Send Mails");
    Button_Send.setBounds(new Rectangle(492, 263, 108, 32));
    Button_Send.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Button_Send_actionPerformed(e);
      }
    });
    Button_Exit.setBounds(new Rectangle(492, 300, 108, 32));
    Button_Exit.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Button_Exit_actionPerformed(e);
      }
    });
    Button_Exit.setText("E X I T");
    Button_Exit.setFont(new java.awt.Font("Dialog", 0, 15));
    Button_Help.setBounds(new Rectangle(492, 337, 108, 32));
    Button_Help.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Button_Help_actionPerformed(e);
      }
    });
    Button_Help.setText("Help");
    Button_Help.setFont(new java.awt.Font("Dialog", 0, 15));
    Button_Clear.setText("Clear");
    Button_Clear.setBounds(new Rectangle(543, 378, 69, 15));
    Button_Clear.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Button_Clear_actionPerformed(e);
      }
    });
    this.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(ComponentEvent e) {
                this_componentResized(e);
            }
    });
    jLabel15.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel15.setHorizontalTextPosition(SwingConstants.RIGHT);
    jLabel15.setText("*");
    jLabel15.setBounds(new Rectangle(24, 296, 34, 17));
    jLabel16.setToolTipText("");
    jLabel16.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel16.setHorizontalTextPosition(SwingConstants.RIGHT);
    jLabel16.setText("*");
    jLabel16.setBounds(new Rectangle(17, 321, 41, 23));
    jLabel17.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel17.setHorizontalTextPosition(SwingConstants.RIGHT);
    jLabel17.setText("*");
    jLabel17.setBounds(new Rectangle(21, 347, 37, 23));
    jLabel18.setFont(new java.awt.Font("Dialog", 1, 13));
    jLabel18.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel18.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel18.setText("Delay In Sec");
    jLabel18.setBounds(new Rectangle(484, 206, 81, 26));
    ComboBox_Delay.setBounds(new Rectangle(568, 208, 51, 22));
    this.setTitle("SendMail");
        Panel_Main.add(jLabel2, null);
    Panel_Main.add(Edit_SmtpServer, null);
    Panel_Main.add(jLabel6, null);
    Panel_Main.add(jLabel7, null);
    Panel_Main.add(Edit_Pop3Server, null);
    Panel_Main.add(Edit_MailID, null);
    Panel_Main.add(jLabel8, null);
    Panel_Main.add(Edit_UserName, null);
    Panel_Main.add(Edit_Password, null);
    Panel_Main.add(jLabel5, null);
    Panel_Main.add(jLabel3, null);
    this.getContentPane().add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(Panel_Main, null);
    Panel_Main.add(jScrollPane2, null);
    jScrollPane2.getViewport().add(List_Status, null);
    Panel_Main.add(Button_Clear, null);
    Panel_Main.add(Edit_Subject, null);
    Panel_Main.add(jLabel4, null);
    Panel_Main.add(jLabel9, null);
    Panel_Main.add(jLabel10, null);
    Panel_Main.add(jLabel11, null);
    Panel_Main.add(jLabel12, null);
    Panel_Main.add(jLabel13, null);
    Panel_Main.add(jLabel14, null);
    Panel_Main.add(Edit_AttachmentFile3, null);
    Panel_Main.add(Edit_AttachmentFile2, null);
    Panel_Main.add(Edit_AttachmentFile1, null);
    Panel_Main.add(Edit_ToFile, null);
    Panel_Main.add(Edit_ContentFile, null);
    Panel_Main.add(Button_ContentFile, null);
    Panel_Main.add(Button_ToFile, null);
    Panel_Main.add(Button_AttachmentFile1, null);
    Panel_Main.add(Button_AttachmentFile2, null);
    Panel_Main.add(Button_AttachmentFile3, null);
    Panel_Main.add(jLabel15, null);
    Panel_Main.add(jLabel16, null);
    Panel_Main.add(jLabel17, null);
    Panel_Main.add(CheckBox_SendCopyToMe, null);
    Panel_Main.add(Button_Exit, null);
    Panel_Main.add(Button_Send, null);
    Panel_Main.add(Button_Help, null);
    Panel_Main.add(jLabel1, null);
        Panel_Main.add(jLabel18, null);
        Panel_Main.add(ComboBox_Delay, null);

    ComboBox_Delay.addItem("0");
    ComboBox_Delay.addItem("1");
    ComboBox_Delay.addItem("5");
    ComboBox_Delay.addItem("10");
    ComboBox_Delay.addItem("15");
    ComboBox_Delay.addItem("30");
    ComboBox_Delay.addItem("60");
    ComboBox_Delay.addItem("120");
    ComboBox_Delay.addItem("300");
    ComboBox_Delay.addItem("600");
    ComboBox_Delay.addItem("900");
  }

  void this_componentResized(ComponentEvent e) {
         this.setSize(630, 530);
  }

  void Button_ContentFile_actionPerformed(ActionEvent e) {
       Edit_ContentFile.setText( GeneralUtility.selectFile(this) );
  }

  void Button_ToFile_actionPerformed(ActionEvent e) {
       Edit_ToFile.setText( GeneralUtility.selectFile(this) );
  }

  void Button_AttachmentFile1_actionPerformed(ActionEvent e) {
       Edit_AttachmentFile1.setText( GeneralUtility.selectFile(this) );
  }

  void Button_AttachmentFile2_actionPerformed(ActionEvent e) {
       Edit_AttachmentFile2.setText( GeneralUtility.selectFile(this) );
  }

  void Button_AttachmentFile3_actionPerformed(ActionEvent e) {
       Edit_AttachmentFile3.setText( GeneralUtility.selectFile(this) );
  }

  void Button_Exit_actionPerformed(ActionEvent e) {
       if(JOptionPane.showConfirmDialog(this, "Do you really want to quit ?", "QUIT", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
           System.exit(0);
       }
  }

  void Button_Help_actionPerformed(ActionEvent e) {
       JOptionPane.showMessageDialog(this, "Please refer to the documentation that comes along with the installater.");
  }

  void Button_Clear_actionPerformed(ActionEvent e) {
       listModelStatus.removeAllElements();
  }


  void Button_Send_actionPerformed(ActionEvent e) {
       try {
           if(Edit_MailID.getText().trim().length()<=0 || Edit_SmtpServer.getText().trim().length()<=0 || Edit_Pop3Server.getText().trim().length()<=0 || Edit_UserName.getText().trim().length()<=0 || Edit_Password.getText().trim().length()<=0 || Edit_Subject.getText().trim().length()<=0 || Edit_ContentFile.getText().trim().length()<=0 || Edit_ToFile.getText().trim().length()<=0) {
               JOptionPane.showMessageDialog(this, "All the fields without * are mandatory, so enter proper data into them", "Mandatory Data", JOptionPane.ERROR_MESSAGE);
               return;
           }
           if(GeneralUtility.validateEMailID(Edit_MailID.getText().trim()) == false) {
               JOptionPane.showMessageDialog(this, "Please enter a valid email address for \"Full Mail ID\" field.", "Invalid E-Mail", JOptionPane.ERROR_MESSAGE);
               return;
           }
           Postman pm = new Postman();
           String anotherTo = null;
           String message = GeneralUtility.getFileContent(Edit_ContentFile.getText());
           try {
               pm.initialize(Edit_MailID.getText().trim(), Edit_SmtpServer.getText().trim(), Edit_Pop3Server.getText().trim(), message.trim(), Edit_UserName.getText().trim(), Edit_Password.getText().trim(), Edit_AttachmentFile1.getText().trim(), Edit_AttachmentFile2.getText().trim(), Edit_AttachmentFile3.getText());
           } catch (Throwable initEx) {
               listModelStatus.addElement("E R R O R  :  Failed to Connect to POP3 Server" );
               listModelStatus.addElement("Please check if the connection information is correct");
               initEx.printStackTrace();
           }

           if(CheckBox_SendCopyToMe.isSelected() == true) {
               anotherTo = Edit_MailID.getText();
           }
           Vector v = GeneralUtility.getNextToAndSubject(Edit_ToFile.getText(), Edit_Subject.getText().trim());
           int numElements = v.size();
           String currentMailID="", currentSubject="";
           long millisec = Long.parseLong(((String)ComboBox_Delay.getSelectedItem()))*1000;
           for(int i=0; i<numElements; i=i+2) {
                   this.update(this.getGraphics());
                   Thread.currentThread().sleep(millisec);
                   try {
                       currentMailID = (String)(v.get(i));
                       currentSubject = (String)(v.get(i+1));
                       pm.sendMail(currentMailID, anotherTo, currentSubject);
                       listModelStatus.addElement("++Succesfully sent email with EMailID="+currentMailID+ " and Subject="+currentSubject);
                   } catch(Throwable sendEx) {
                       listModelStatus.addElement("--Failed to send email with EMailID="+currentMailID+ " and Subject="+currentSubject);
                       listModelStatus.addElement("So retrying to send the EMail again");
                       sendEx.printStackTrace();
                       i=i-2;
                       continue;
                   }
           }
       } catch (Throwable appEx) {
         listModelStatus.addElement("E R R O R  : Failed to initialize the application.");
         listModelStatus.addElement("Please refer to the documentation");
         appEx.printStackTrace();
       }
  }



}